# Call of Duty: Black Ops 2 Zombies - Reimagined

## Created by: Jbleezy

[YouTube](https://youtube.com/ItsJbirdJustin)

[Twitch](https://twitch.tv/Jbleezy)

[Twitter](https://twitter.com/ItsJbleezy)

[Discord](https://dsc.gg/Jbleezy)

[Donate](https://ko-fi.com/Jbleezy)

## Change Notes

## General
* Removed round cap
* Removed fog
* Disabled depth of field
* Increased level of detail at longer distances
* Announcer audio always plays
* In-game menu no longer disabled instantly when the game ends

## HUD
* Enemy counter displayed on top left of screen - `hud_enemy_counter`
* Timer displayed on top right of screen - `hud_timer`
* Health bar displayed on bottom left of screen - `hud_health_bar`
* Zone name displayed on bottom left of screen - `hud_zone_name`
* Increased waypoint offset from top of screen
* Changed player waypoint location to be center of player instead of top of player
* Increased distance between revive waypoint arrow and icon
* Bleed out bar displayed when downed
* Revive bar displayed for downed player
* Changed revive bar color to blue
* Player is reviving you text gets removed instantly when player drops the revive
* Player needs to be revived text updates to new player instantly
* Removed NAV cards

## Players
* Unlimited sprint
* Increased health from 100 to 150
* Self revives in solo are active whenever the player has at least 1 perk
* Upgraded starting pistol given as self revive pistol above all others except Ray Gun Mark 2
* 100% backwards move speed
* Decreased sprint time needed to be able to dive from 0.25 seconds to 0.1 seconds
* Can move immediately after diving
* Can dive again right away after just diving
* Increased melee range by 16% (same as Black Ops 1)
* Disabled melee lunging
* Disabled meleeing while doing falling hands anim
* Can look up and down 90 degrees (previously 85 degrees)
* Decreased normal health regeneration delay from 2.4 seconds to 2 seconds
* Decreased low health regeneration delay from 5 seconds to 4 seconds
* Normal health regeneration rate is no longer instant
* Changed health regeneration rate to 100 health per second (normally fully restored health in 0.5 seconds)
* Changed low health threshold from 20% of player's max health to 50 health
* Fall damage no longer increases when max health is increased
* Added blood fx when at or below 20% health
* Removed blur after getting damaged
* Removed shellshock from explosive damage
* No longer killed when landing on top of another player
* Ignored by zombies for 1 second after being revived
* Disabled meleeing while reviving (except if player switches weapons)
* Pressing the fire button while reviving no longer switches weapons
* Weapon is no longer switched after reviving if player switched weapons during revive
* No longer gain points back on self revives
* Respawn near random player (normally respawn near the same player every time)
* Can shoot while looking at other players
* Increased mantle speed
* Increased ladder climb speed
* Start with Semtex on maps that have Semtex
* Barriers can no longer be rebuilt while sprinting or thowing a grenade
* Upgraded weapon camo is applied in last stand
* Dual wield last stand weapon is switched to when ammo is only in left clip
* Decreased friendly player name fade out time from 1.5 seconds to 0.25 seconds
* Removed enemy player name fade in time
* Added icons on scoreboard when player is downed, bled out, in Who's Who mode, or in afterlife
* Added option to disable character dialog - `disable_character_dialog`

## Zombies
* Health capped at 100,000
* Decreased player damage from 60 to 50
* Changed height to 60 (normally either 48 or 72)
* Increased damage taken to make a crawler from 10% of current health to 25% of current health
* Amount of zombies scales linearly with the amount of players
* Zombies that are deleted due to being too far away always respawn
* Attracted towards points of interest immediately
* Removed walkers in high rounds
* Removed headless zombies
* Neck counts as headshot
* All body shot kills award 50 points
* 4 round and 5 round special rounds happen more equally
* Fixed not being able to drop powerups after doing certain traversals

### Avogadro
* Drops a random powerup when killed
* Decreased minimum distance away from players to be able to attack
* Respawns on the same round if exited due to being too far away from players (normally respawns on the next round)

### Denizens
* Changed max amount that can be spawned at once from 2 total to 1 per player in the fog
* Changed spawn rate to 5 seconds (normally same spawn rate as zombies)
* Decreased health from 200 to 150
* Decreased number of melees to kill from 5 to 3
* Decreased number of melees to kill with Bowie Knife from 3 to 2
* Decreased number of melees to kill with Galvaknuckles from 2 to 1
* No longer automatically runs away when player is first attacked in solo
* Removed hint when player is first attacked in solo

### Leapers
* No longer give each player 2000 points when rewarded a free perk powerup
* Initial leaper round always happens on round 5 or 6
* Fixed getting kill points twice

### Brutus
* Smoke Grenade kills zombies
* Decreased player damage from 99 to 90
* No longer receives additional damage from Ray Gun Mark 2
* Teleports away less frequently
* Grief: spawns every 4-6 minutes

### Panzersoldat
* No longer receives additional damage from Boomhilda or Ray Gun Mark 2

## Weapons
* Switch to melee weapon by pressing the Previous Scorestreak button (same button as the Time Bomb and Maxis Drone)
* Grenades: improved projectile upward speed
* Grenades: can no longer be thrown faster than intended by throwing a grenade right after throwing one
* Grenades: changed damage scalar to 25 multiplied by round number (normally random number between 100 and 200 added by round number)
* Grenades: capped damage scalar at 1500
* Projectile weapons: changed projectile weapon damage scalar to 50 multiplied by round number (normally random number between 0 and 100 multiplied by round number)
* Projectile weapons: capped projectile weapon damage scalar at 3000
* Placeable mines: changed damage scalar to 150 multiplied by round number (normally random number between 100 and 200 multiplied by round number)
* Placeable mines: capped damage scalar at 9000

## Pistols
* Increased move speed from 100% to 110%

### B23R
* Decreased weapon cost from 1000 to 900 on all maps

### Executioner
* Removed on Buried

### Five-seven Dual Wield
* Unupgraded: decreased stock ammo from 225 to 210 on all maps
* Upgraded: decreased stock ammo from 295 to 280 on all maps

### KAP-40
* Removed delay between last shot and reload
* Unupgraded: increased clip ammo from 12 to 15
* Unupgraded: increased stock ammo from 96 to 240
* Upgraded: increased stock ammo from 180 to 360

### M1911
* Unupgraded: decreased zoom FOV from 65 to 60 (same as other Black Ops 2 pistols)
* Upgraded: decreased stock ammo from 50 to 48
* Upgraded: decreased last stand ammo from 2 clips to 1 clip

### Mauser C96
* Ammo gets added to the clip at the same time that it gets added in the reload anim
* Unupgraded: decreased zoom FOV from 65 to 60 (same as other Black Ops 2 pistols)
* Upgraded: fixed not being able to melee while aiming
* Upgraded: decreased last stand ammo from 2 clips to 1 clip

### Python
* Removed

### Tac-45
* Replaces M1911 (except on Mob of the Dead)

## Assault Rifles

### AN-94
* Increased weapon cost from 1200 to 1500
* Upgraded: decreased stock ammo from 600 to 450

### FAL OSW
* Replaces FAL

### Galil
* Removed

### M27
* Added to the Mystery Box on all maps
* Upgraded: changed default attachment from Reflex Sight to None

### M8A1
* Decreased recoil

### MTAR
* Decreased recoil
* Upgraded: changed default attachment from Reflex Sight to EOTech Sight

### SCAR-H
* Added to the Mystery Box on all maps
* Upgraded: changed default attachment from Reflex Sight to None

### SMR
* Replaces M14
* Removed from Mystery Box
* Removed aim spread
* Unupgraded: decreased clip ammo from 20 to 10
* Unupgraded: decreased stock ammo from 140 to 100
* Upgraded: decreased clip ammo from 30 to 20
* Upgraded: decreased stock ammo from 420 to 200
* Upgraded: increased damage by 50%
* Upgraded: increased headshot multiplier from 4 to 4.5

### STG-44
* Ammo gets added to the clip at the same time that it gets added in the reload anim
* Upgraded: decreased stock ammo from 330 to 300

### Type 25
* Decreased recoil
* Unupgraded: increased stock ammo from 150 to 300
* Upgraded: increased stock ammo from 270 to 450
* Upgraded: changed default attachment from Reflex Sight to Millimeter Scanner

## Submachine Guns
* Changed move speed from 100% or 110% to 105%

### Chicom CQB
* Unupgraded: decreased clip ammo from 40 to 36
* Unupgraded: increased stock ammo from 120 to 288
* Upgraded: increased clip ammo from 40 to 48
* Upgraded: increased stock ammo from 200 to 384
* Upgraded: changed default attachment from None to Select Fire

### M1927
* Decreased ammo cost from 800 to 750

### MP40
* Ammo gets added to the clip at the same time that it gets added in the reload anim

### Skorpion EVO
* Upgraded: changed default attachment from Reflex Sight to Fast Mag

## Light Machine Guns
* Decreased move speed from 87.5% to 85%

### HAMR
* Decreased recoil
* Upgraded: changed default attachment from None to Grip

### MG08/15
* Ammo gets added to the clip at the same time that it gets added in the reload anim

## Sniper Rifles
* Decreased move speed from 95% to 90%
* Disabled scope sway
* Unupgraded: increased scope FOV from 15 or 20 to 25

### Ballista
* Replaces Olympia

## Shotguns
* Increased penetration

### Remington 870
* Changed weapon cost from 900 or 1500 to 1200 on all maps

## Launchers

### War Machine
* Unupgraded: grenades explode on impact

## Specials

### Ballistic Knife
* Added model and anims from Black Ops 2 Multiplayer
* Increased melee time from 0.5 seconds to 0.7 seconds
* Projectiles are no longer destroyed when other players walk over them
* Projectiles are no longer destroyed when purchasing a melee wallbuy
* Projectiles get destroyed by lava
* Projectiles can be picked up while the weapon is not reloaded
* Projectiles can be picked up while the player is not on the ground

## Wonder Weapons

### Ray Gun
* Added weapon model from Buried to all maps
* Increased move speed from 100% to 105%
* Ammo gets added to the clip at the same time that it gets added in the reload anim
* No longer limited to 4 players
* Unupgraded: increased impact damage from 1000 to 1500 (same as max splash damage)
* Upgraded: increased impact damage from 1000 to 2000 (same as max splash damage)

### Ray Gun Mark 2
* Same probability to obtain as other weapons
* Can be obtained if player has Ray Gun
* Increased move speed from 100% to 105%
* Ammo gets added to the clip at the same time that it gets added in the reload anim
* Limited to 1 player on all maps
* Decreased last stand ammo from 3 clips to 1 clip

### Jet Gun
* Kills multiple zombies significantly faster
* Kills zombies that are in the ground, traversing, or behind barriers
* Awards points for kills
* Heats up half as fast
* Cools down twice as fast
* Cools down while not holding weapon
* No longer kills when not firing
* No longer automatically switched to weapon when picked up
* No longer disassembles when overheated
* Weapon is taken when overheated
* Buildable table model no longer shows when player has weapon
* Changed weapon name on HUD from "Thrustodyne Aeronautics Model 23" to "Jet Gun"

### Sliquifier
* Added upgraded version
* Kills on any round (normally stops killing after round 100)
* Decreased stock ammo from 40 to 20
* Removed additional goo created by chain kills
* Continues to chain while not holding weapon
* Removed player damage
* Upgraded: increases slippery spot duration by 50%
* Upgraded: increases chain explosion radius by 50%
* Added teddy bear to buildable table after weapon is taken from it
* Teddy bear standing up means weapon is not available from Mystery Box
* Teddy bear lying down means weapon is available from Mystery Box

### Paralyzer
* Kills on any round
* Decreased max player fly height

### Blundergat
* Kills on any round in 1-2 shots
* Increased pellet count from 7 to 8
* Increased pellet size

### Acid Gat
* Kills on any round in 1-2 bursts
* Changed fire type from 3 round burst to 4 round burst
* Increased player damage from 10 to 15
* Projectiles fire in a straight line
* Projectiles no longer seek toward zombies
* Deadshot improves accuracy
* Stuck zombie counts as a kill
* Upgraded: fixed fire sound

### Staffs
* Upgrade only requires collecting souls in The Crazy Place
* Can no longer collect souls in The Crazy Place from staff kills
* Can collect souls in The Crazy Place after upgrading to fill 5% of max ammo per soul
* Picking up a staff at The Crazy Place while holding a staff places the other staff at The Crazy Place
* Insterting a staff in The Crazy Place requires player's current weapon to be the staff
* Fixed triggers for inserting and picking up staffs in The Crazy Place
* Fixed being able to carry multiple staffs by picking up a staff with staff revive weapon out
* Get full ammo when initially picked up after upgrading (normally missing one clip)
* Max ammo no longer fills clip ammo
* Upgraded: kill on any round
* Upgraded: charged shots damage Panzersoldat
* Upgraded: decreased alt weapon fire time from 3 seconds to 0.5 seconds
* Fire upgraded: charged shots no longer deal additional damage to Panzersoldat
* Ice upgraded: fixed melee sound

## Tactical Grenades

### Monkey Bomb
* Added model and HUD icon from Buried to all maps
* Zombies killed can drop powerups
* Fixed an issue where a Monkey Bomb wouldn't activate if the previously thrown Monkey Bomb hadn't activated yet

### EMP Grenade
* No longer disables HUD
* Disables player's perks for 12 seconds
* Increased ammo from 2 to 3
* Decreased projectile speed by 30% (same as Black Ops 2 Multiplayer EMP Grenade)
* Decreased zombie EMP radius by 17% (same as Black Ops 2 Multiplayer EMP Grenade)
* Increased perk machine EMP radius by 22% (same as Black Ops 2 Multiplayer EMP Grenade)
* Decreased perk machine EMP time from 90 seconds to 60 seconds
* Changed shellshock (same as Black Ops 2 Multiplayer EMP Grenade)
* Added fx to EMP'd players
* Can destroy deployed Zombie Shields
* Sprinting no longer wakes up EMP'd zombies
* Zombies that are in the ground can no longer get EMP'd

### Smoke Grenade
* Added on Mob of the Dead
* Kills on any round

### Hell's Retriever
* No longer ricochets to other zombies when not charged
* Every charge increases total zombies attacked by 3
* Unupgraded: changed damage to 2000 (normally does 1000-2000 damage based on number of charges)
* Upgraded: kills on any round when not charged

### G-Strike Beacon
* Kills on any round
* Increased ammo from 2 to 3

## Equipment
* Increased move speed from 100% to 110%

### Combat Knife
* Added model from Black Ops 2 Multiplayer

### Claymore
* Can be repurchased
* Can be placed while in the air
* Increased max amount that can be placed from 12 to 20
* Added weapon name on HUD
* Removed initial weapon raise anim

### Time Bomb
* No longer sends players back in time
* Kills all zombies
* Can have with Monkey Bombs
* Switches to detonator at correct time after throwing
* Fixed detonator raise and drop anims

### One Inch Punch
* Upgraded: elemental punch changes based on which staff the player currently has
* Upgraded: uses melee lunge anim as normal melee anim
* Fixed an issue where a player's melee weapon wouldn't reset if the player bled out in the Giant Robots

## Wallbuys
* Purchasing ammo refills clip ammo
* Increased trigger radius
* Decreased upgraded ammo cost from 4500 to 2500
* Ammo can be purchased if only alt weapon ammo has been used
* Purchasing no longer shows the weapon model at other wallbuys of the same weapon
* Lethal grenade hint string no longer displays "ammo" after purchasing
* Downing while purchasing a melee weapon gives the melee weapon
* Added melee wallbuy HUD icons to all maps

## Mystery Box
* Players get every weapon they can before getting duplicates
* Players only see weapons rising up that they can currently obtain
* Decreased weapon pickup time from 12 seconds to 9 seconds
* Moves to new location instantly
* Special sound no longer plays when obtaining the Ray Gun
* Special sound plays when obtaining a limited weapon

## Perks
* Removed perk limit
* Removed blur after drinking
* No longer deactivated if the perk machine is powered off
* Added high qualty perk icons to all maps

### Jugger-Nog
* Increases current health by 100 upon purchase (normally sets current health to max)

### Quick Revive
* No longer automatically powered on in solo
* Increased cost in solo from 500 to 1500
* Decreases revive time by 33.33%
* Decreases health regeneration delay by 25%
* Changed hint string from "Revive" to "Quick Revive"

### Speed Cola
* Aim twice as fast
* Switch weapons twice as fast
* Throw grenades twice as fast

### Double Tap
* Removed shooting 2 bullets for every shot
* Increases bullet damage by 50%

### Stamin-Up
* Increased cost from 2000 to 2500
* Move 7% faster (normally only sprint 10% faster)

### PHD Flopper
* Added perk bottle model from Origins to all maps
* Deals same damage on all maps
* Damages all zombies at once on all maps

### Deadshot Daiquiri
* Increases bullet headshot damage by 100%
* Move faster while aiming
* Decreases sprint recovery time

### Mule Kick
* Added additional weapon indicator
* Additional weapon is given back when perk is reacquired
* Stowed weapons automatically reload over time

### Tombstone Soda
* Added in solo and Grief
* Powerup no longer removed when revived
* Powerup removed when downed again after being revived or respawning
* Unlimited time to pick up powerup
* Changed powerup fx color to blue
* Powerup gets destroyed by EMP Grenades
* Restores all weapons properly
* Disabled suicide option when player is down
* Added powerup waypoint
* Flipped perk icon
* Changed hint string from "Tombstone" to "Tombstone Soda"

### Who's Who
* Keep weapons when entering Who's Who mode
* Spawn facing towards the clone when entering Who's Who mode
* Keep any perks obtained in Who's Who mode when exiting Who's Who mode
* Decreased Who's Who mode duration from 45 seconds to 30 seconds
* Self revives in solo always activate during Who's Who mode
* Ignored by zombies for 1 second after entering Who's Who mode
* Invulnerable for 2 seconds after entering and exiting Who's Who mode
* Controls are frozen for 0.5 seconds after entering and exiting Who's Who mode
* Purchasing Who's Who in Who's Who mode no longer destroys the clone
* Downing with Who's Who in Who's Who mode destroys the clone
* Added Who's Who mode duration bar on HUD
* Changed revive waypoint icon to Who's Who perk icon
* Revive waypoint shows offscreen
* Fixed an error that would crash the game when entering Who's Who mode

### Electric Cherry
* Removed cooldown after being used multiple times in a row
* Downing kills all zombies around the player

### Vulture-Aid
* Stink areas no longer activate while the player is moving

## Pack-a-Punch
* Attachments on upgraded weapons can no longer be changed
* Decreased weapon pickup time from 15 seconds to 12 seconds
* Added sound when attempting to purchase without enough points

## Powerups
* Decreased chance to drop from 3% to 2%
* Grabbing time based powerups that are already active add to timer instead of resetting timer
* Fx plays when a powerup drops if it is the last powerup of a cycle

### Nuke
* Kills all zombies instantly

### Carpenter
* Removed

### Zombie Blood
* No longer makes zombies ignore the player
* Makes the player invulnerable to zombie melee swipes

### Meat
* All zombies go after player holding the meat
* 75% move speed while holding the meat
* Take 50 damage per second if stationary while holding the meat
* Decreased throw speed by 25%
* Player who threw the meat can meat themself
* Attracts zombies more consistently on ground
* Decreased attract radius on ground by 50%
* Decreased time on ground from 16 seconds to 10 seconds
* Decreased time on players from 30 seconds to 15 seconds
* Bounces off walls when thrown
* Added weapon name on HUD
* Changed powerup fx color to blue
* Able to drop when players are down
* No longer able to drop when another meat powerup is already dropped
* Message shows when the meat is grabbed and landed on a player
* Meleeing while the meat is moving no longer grabs the meat
* Removed pick up trigger
* Gets destroyed when thrown on lava
* Replaced with Richtofen's Head on Cell Block and Docks

## Persistent Upgrades
* Removed

## Buildables
* Added purchase cost
* Parts automatically picked up
* Can be built at any table on all maps
* Zombies no longer attack (except Zombie Shield)
* Can no longer be destroyed by 2 grenades
* Can be destroyed by taking 1500 damage
* Can no longer be picked up after being destroyed
* Added weapon name on HUD to all buildables
* Increased move speed while holding from 100% to 110% (except Zombie Shield)
* Changed crafting hint string from "Building..." to "Crafting..."

### Zombie Shield
* Added shield health bar on HUD
* Awards points for kills and damage
* Can be destroyed by player damage when deployed
* Destroyed sound plays when player is holding
* Deployed damage sound plays on shield instead of player
* Switches back to correct weapon after deploying

### Turret
* No longer needs to be powered by a Turbine
* Gets destroyed after being deployed for 30 seconds
* Kills on any round in 1-4 shots (normally does 1200 damage max)
* No longer damages players
* Fire type changed from burst fire to continuous fire
* Fixed an issue where the Turret sounds would continue playing after being picked up

### Electric Trap
* No longer needs to be powered by a Turbine
* Gets destroyed after being deployed for 30 seconds
* Kills on any round (normally stops killing after round 50)
* Kills zombies instantly
* No longer kills players without Juggernog instantly
* Decreased player damage from 75 to 25
* Decreased player shellshock time from 2.5 seconds to 1.25 seconds
* Decreased startup time from 2 seconds to 0.5 seconds

### Subsurface Resonator
* No longer needs to be powered by a Turbine
* No longer gets destroyed from kills
* Gets destroyed after being deployed for 30 seconds
* Fires every 2 seconds (normally has a longer delay depending on the amount of kills from the previous fire)

### Trample Steam
* No longer gets destroyed from kills
* Gets destroyed after activating 15 times
* Does fast cooldown when player activates

### Head Chopper
* No longer gets destroyed from kills
* Gets destroyed after activating 10 times
* Does multiple swings when player activates
* Kills zombies when placed on a ceiling
* Increased damage trigger width by 100%
* No longer deals damage during retract anims
* Changed head chop player damage to 50 (normally instantly kills without Juggernog or deals 15 damage with Juggernog)
* Changed body chop player damage to 25 (normally deals 75 damage to torso or 37 damage to feet)
* Fixed an issue where each chop would only damage entities that were touching the damage trigger during the previous chop

### Blundergat Upgrade
* Player does knuckle crack anim during conversion
* Requires player's current weapon to be the Blundergat to convert
* Requires player to be looking at the table to convert

### Maxis Drone
* Kills on any round in 1-4 shots (normally does 12000 damage max)
* Decreased active time from 90 seconds to 60 seconds
* Decreased cooldown time from 60 seconds to 30 seconds
* Added hint strings for purchased, can only be one, and cooling down
* Buildable table model sits on top of the stand
* Rotated buildable table model 90 degrees
* Switches back to correct weapon after deploying

## Bank
* Deposited points resets each game
* Gain 10% interest on deposited points at the end of each round
* No longer costs 100 points to withdraw
* Players can deposit and withdraw less than 1000 points
* Account balance displayed on HUD
* Disabled trading points

## Weapon Locker
* Placed weapon resets each game
* Placed weapon gains max ammo at the end of each round
* Placed weapon displayed on HUD

## NAV Table
* Automatically crafted
* Costs 100,000 points
* Ends the game

## Maps
* All quests can be completed with any amount of players
* All quests give players all perks on completion

### Tranzit
* Power switch and Pack-a-Punch automatically crafted
* Any door that requires a Turbine to open is automatically open whenever the power is on
* Increased bus speed by 100%
* Added bus depart timer on HUD when player is on bus
* Powerups dropped within the bus are linked to the bus
* Players can sprint and go prone on the bus
* Bus wallbuy trigger functions the same as other wallbuy triggers
* Lava in starting area activates after the power is on
* Lava destroys grenades instantly
* Lava damage no longer changes based on player's health
* Decreased light lava damage from 6 to 5
* Decreased zombie explosion max damage from 30 to 15
* Players can be revived in the fog easier
* Lamp post portals stay active after activating once
* Each lamp post portal teleports players to a set destination lamp post (randomizes each game)
* Decreased brightness at Power Station
* Zombies killed by the bus no longer respawn
* Zombies no longer spawn in the Prototype zone when in the Cornfield zone
* Zombies no longer spawn in the Cornfield zone when in the Prototype zone
* Zombies spawn in the Warehouse zone when in the Outside Power Station zone before the Warehouse door is opened
* Zombies spawn in the Outside Power Station zone when in the Fog After Power Station zone
* Zombies spawn in the Warehouse zone when in the Fog After Power Station zone
* Quest: increased pylon powerup drop rate from 4-12 minutes to 2-6 minutes
* Quest (Maxis): Avogadro step only requires 1 Turbine under the pylon
* Quest (Maxis): Turbine can get destroyed by the EMP during the Avogadro step and it will still count as completed
* Quest (Maxis): lamp posts step requires all 8 lamp posts to get powered by a Turbine
* Quest (Maxis): lamp posts step no longer requires all Turbines to be placed at the same time
* Quest (Richtofen): lamp posts step requires all 8 lamp posts to get powered off by an EMP
* Quest (Richtofen): lamp posts step no longer requires all lamp posts to be powered off at the same time
* Survival & Grief: power doors are buyable doors
* Grief: added Ballistic Knife, Ray Gun, and Ray Gun Mark 2 to the Mystery Box
* Added collision to area at Cornfield that was considered out of the map
* Fixed zombie riser spawn points that were too high above ground
* Fixed zombie pathing at Cornfield behind the pylon
* Fixed zombie pathing at Town in Bookstore

#### Bus Depot
* Added Grief game mode
* Lava in starting area activates immediately
* Lava pit is accessible

#### Diner
* Added Survival and Grief game modes
* Wallbuys: M14, Olympia, MP5, Galvaknuckles
* Perks: Juggernog, Quick Revive, Speed Cola, Double Tap
* No Pack-a-Punch

#### Farm
* Zombies spawn in the Farm zone when in the Barn zone
* Replaced Olympia wallbuy with Remington 870 wallbuy
* Replaced Galvaknuckles wallbuy with Claymore wallbuy (also added to Grief)

#### Power Station
* Added Survival and Grief game modes
* Wallbuys: M14, Olympia, MP5, AK74u, Remington 870, Bowie Knife
* Perks: Juggernog, Quick Revive, Speed Cola, Double Tap, Tombstone Soda
* Pack-a-Punch

#### Town
* Moved Quick Revive to Stamin-Up's location on Town
* Moved Stamin-Up to its location on Tranzit
* Moved Tombstone Soda to the laundry room front door

#### Tunnel
* Added Survival and Grief game modes
* Wallbuys: M14, Olympia, AK74u, M16, Semtex, Bowie Knife
* Added Mystery Box location
* Perks: Juggernog, Quick Revive, Speed Cola, Double Tap, Stamin-Up
* Pack-a-Punch

#### Cornfield
* Added Survival and Grief game modes
* Wallbuys: M14, Olympia, B23R, MP5, AK74u, M16, Remington 870, Semtex, Claymore
* Added Mystery Box location
* No perks
* Pack-a-Punch

### Nuketown
* Initial perk is no longer always Quick Revive in solo
* Initial perk no longer always spawns in the starting area in solo
* Initial perk spawns at round 1 in coop
* Perks spawn every 5 rounds

### Die Rise
* Removed key
* Elevators and escape pod can be called without key
* Added purchase cost to call elevators and escape pod
* Elevators can be locked at their current floor
* Escape pod can be used with any amount of players
* Escape pod can be called up or down
* Moved weapon locker to the downstairs fridge
* Quick Revive elevator randomizes with Speed Cola and Who's Who elevators
* Pack-a-Punch can be used while elevator is moving
* Doors that open the same zone in the Lower Blue Highrise area open together
* Zombies killed by an elevator no longer respawn
* Zombies are no longer killed while spawning in a stationary elevator
* Zombies no longer spawn in the Upper Blue Highrise area when in the Green Highrise area
* Zombies no longer spawn across from the debris in the Lower Orange Highrise area when the debris is closed
* Zombies no longer fall off the map traversing down to the Green Highrise Level 1 area
* Leapers no longer fall off the map traversing up to the Escape Pod Shaft area
* Fixed weapon model angle on upside down Mystery Box
* Fixed zombies spawning in the elevator below the starting room when in the starting room
* Fixed zombies not bleeding out in the Green Highrise Level 1b zone when the debris is closed and there are no players in the zone
* Quest: elevator symbols can be activated without players on every symbol
* Quest: elevator symbols stay active after activating once
* Quest: floor symbols can be activated in any order
* Quest: Trample Steam step only requires one Trample Steam to be placed in the correct position
* Quest: tower legs can be punched in any order
* Quest (Maxis): no longer have to shoot the upgraded Ballistic Knife after collecting the corpses
* Quest (Maxis): ball no longer requires a Trample Steam on the other side
* Quest (Richtofen): decreased number of Sliquifier shots required for each ball from 20 to 10

### Mob of the Dead
* 1 afterlife max in solo
* Entering afterlife no longer takes 2 additional seconds if the player had Electric Cherry
* Spawn facing towards the afterlife player model when entering afterlife
* Doors can no longer be purchased when entering afterlife
* Afterlife player model has collision
* Key no longer shows on HUD
* Plane parts are shared in coop
* Plane parts must be all acquired to craft
* Plane no longer has to be refueled
* Plane reappears immediately after coming back from the Golden Gate Bridge
* Electric chairs appear immediately after crashing at the Golden Gate Bridge
* Zombies spawn sooner after crashing at the Golden Gate Bridge
* Decreased starting room doors cost from 1000 to 750
* Opening one of the starting room doors no longer opens the other
* Brutus no longer spawns if no doors have been opened
* Activating the laundry machine always spawns zombies instead of Brutus
* Docks gate no longer closes when shock box is shocked in afterlife
* Players no longer respawn in the Acid Trap
* Added falling hands anim from Origins
* Acid Trap: kills on any round (normally stops killing after round 158 on PC)
* Acid Trap: kills zombies instantly
* Acid Trap: decreased player damage from 75% of max health to 50% of max health
* Acid Trap: increased time between player damage from 1 second to 1.5 seconds
* Tower Trap: kills on any round in 1 shot
* Tower Trap (upgraded): kills on any round in 1-2 shots
* Tower Trap (upgraded): stays upgraded until the end of the round
* Tower Trap (upgraded): can be upgraded while the trap is not active
* Tower Trap (upgraded): upgrading no longer resets the duration of the trap
* Zombies spawn in the Docks zone when in the Docks Gates zone
* Zombies spawn in the Docks Gates zone when in the Docks zone
* Quest: Blundergat gets full ammo when picked up (normally missing one clip)
* Quest: number pad only needs each number to be shocked once in order to complete
* Quest: can enter the plane in afterlife with any amount of players
* Quest: can enter the plane in afterlife without Weasel
* Quest: if Weasel is the only player in the game, the cycle breaks immediately after reviving yourself on the Golden Gate Bridge
* Quest: if Weasel is not in the game, the cycle continues immediately after everyone revives themselves on the Golden Gate Bridge
* Quest: players no longer get moved to different positions when starting the showdown
* Quest: showdown target waypoint shows offscreen
* Fixed initial weapon raise anim happening after exiting afterlife
* Fixed being able to hit a death barrier when jumping off the Docks Bridge zone
* Fixed locked hint string not showing on Blundergat Upgrade buildable table

#### Docks
* Added Grief game mode
* Wallbuys: M14, Olympia, MP5, Uzi, M1927
* Perks: Juggernog
* Pack-a-Punch
* Grief: Tower Trap targets and stuns players

### Buried
* Removed Turbine, key, booze, and candy
* Power automatically on
* Noose and Guillotine parts automatically picked up
* Drawing weapons no longer gives points
* Arthur barricades are buyable debris
* Arthur can be purchased to feed him candy and make him run around and kill zombies for 30 seconds
* Ghosts no longer spawn and go after players not in the Mansion during a ghost round
* Ghosts no longer drop free perk powerup if any player gets damaged by the ghosts
* Fountain portal automatically active
* Players no longer take fall damage after using the fountain teleporter
* Players can no longer get into the corner next to Juggernog
* Removed buildable table hint icons
* Added buildable table hint strings on buildable purchase
* Quest: all 5 signs must be meleed for wisp to spawn
* Quest: changed number of targets that need to be hit to 20 multiplied by the amount of players
* Quest: perks given on completion are no longer permament
* Quest: completion button always activatable after completing the quest
* Quest (Maxis): no longer need to activate the Time Bomb to be able to spawn the 2nd wisp
* Quest (Maxis): no longer need to activate the lever in the Mansion before activating the bells
* Quest (Maxis): bells can be activated in any order
* Quest (Richtofen): can enter round infinity without having all players next to the Guillotine
* Quest (Richtofen): Maze levers can be activated in an order
* Quest (Richtofen): Richtofen zombie can only drop powerup if killed by a player

#### Borough
* Upper tunnels and bank area disabled
* Players spawn at Stables
* Mystery Box initially spawns at a random location
* Added B23R, M16, Claymore, and Bowie Knife wallbuys at their locations on Buried
* Added PDW wallbuy at Morgue
* Added SVU wallbuy at Church
* Moved Quick Revive to Speed Cola's location on Borough
* Moved Speed Cola to its location on Buried
* Moved Stamin-Up to Vulture Aid's location on Buried
* Buildables can spawn at Church buildable table
* Added better randomization for buildables

#### Maze
* Added Grief game mode
* Wallbuys: M14, Olympia, B23R, PDW, AN94, LSAT
* Perks: Juggernog, Quick Revive, Speed Cola, Double Tap, Stamin-Up, Mule Kick
* Pack-a-Punch
* Perk and wallbuy locations within the maze are randomized each game

### Origins
* Door prices in solo cost the same as in coop
* Shovels automatically picked up
* Records automatically picked up
* Gramophone initially spawns at Excavation Site gramophone table
* Musical parts no longer show on HUD
* Generators: increased capture reward points from 100 to 200
* Generators: always give back refund points if player was in the generator zone when captured
* Generators: recapture round zombies only drop Max Ammo if killed before taking first generator
* Generators: fixed an issue where recapture sound and fx would play twice
* Giant Robots: each robot has an openable foot when 3 robots are active
* Tank: players can go prone
* Tank: changed cooldown to 30 seconds (normally 2-120 seconds depending on how long players were on the tank)
* Teleporters: stay active after picking up gramophone
* Teleporters: placing gramophone activates The Crazy Place teleporters
* Teleporters: players face away from the teleporters when returning from The Crazy Place
* Teleporters: players can teleport while prone
* Mystery Box: rotated weapon model angle 180 degrees
* Mystery Box: uses the same trade weapon hint string as other maps
* Der Wunderfizz: increased cost from 1500 to 2500
* Der Wunderfizz: all perks have an equal chance of being obtained
* Der Wunderfizz: moves to new location instantly
* Rituals of the Ancients: spend points challenge reward changed from Double Tap perk to a random perk that the player does not have (perk does not change if reward is reopened)
* Soul boxes: decreased number of souls to close from 30 to 20
* Dig spots: decreased number of digs to obtain golden shovel from 30 to 20
* Dig spots: changed number of digs to obtain golden helmet to 40 (normally 5% chance to obtain after obtaining golden shovel)
* Dig spots: dug up weapons get full ammo when picked up (normally missing one clip)
* Perk bottle dig spots: give random perk
* Perk bottle dig spots: visible and diggable without Zombie Blood
* Perk bottle dig spots: increased number of rounds for next dig spot to spawn from 1 to 4
* Quest (ascend from darkness step): staffs can be placed at any staff holder
* Quest (ascend from darkness step): three robots always active during step
* Quest (ascend from darkness step): fixed an issue where staffs were able to be picked up at their build location when placed in the staff holders
* Quest (rain fire step): button no longer deactivates after activating
* Quest (raise hell step): all staffs must be fully charged for souls to be collected
* Quest (raise hell step): zombies in The Crazy Place get knocked down during the screen flash after collecting all of the souls
* Quest (freedom step): teleport trigger can be triggered without looking at it
* Fixed being able to hit a death barrier when jumping off the Above Generator 3 Bunker zone

## Game Modes

### Encounter
* Group of competitive game modes
* Unlimited zombies
* 2500 health zombies (25000 health Brutus)
* 0.5 second zombie spawn rate
* Only sprinting zombies
* Crawlers bleed out if they have not dealt or taken damage within 30 seconds
* Unlimited powerups
* Unlimited barrier rebuild points
* Unupgraded weapons stun enemy players for 0.5 seconds
* Upgraded weapons stun enemy players for 0.75 seconds
* Melee weapons stun enemy players for 0.75 seconds
* Meleeing enemy players with an upgraded melee weapon pushes 33% more
* Meleeing enemy players that are in the air pushes 100% more
* Meleeing enemy players that are crouched pushes 33% less
* Meleeing enemy players that are prone pushes 66% less
* Meleeing enemy players that are reviving pushes 50% less
* Meleeing enemy players that are already stunned from weapons will push and restun them
* Ballistic knife projectile pushes enemy players
* Claymores are no longer triggered by enemy players
* Stun fx is linked to the player
* Stun fx shows in the correct position for projectiles
* Stunning enemy players steals 100 points from them
* Downing enemy players awards 500 points
* Landing on top of an enemy player that is prone downs them
* Increased max radius for landing on top of an enemy player by 16.66%
* Decreased max height for landing on top of an enemy player by 50%
* Starting weapon (upgraded): decreased stock ammo by half
* Max Ammo: decreased amount of ammo given from max stock to one clip
* Max Ammo: unloads clip of all enemy players' weapons and takes away their grenades and claymores
* Double Points: decreased duration from 30 seconds to 15 seconds
* Double Points: enemy players gain half points
* Insta Kill: decreased duration from 30 seconds to 15 seconds
* Insta Kill: enemy players deal half damage
* Nuke: enemy players lose 400 points
* Nuke: deals 75 damage to all alive enemy players
* Nuke: makes all downed enemy players bleed out
* Added teammate head icons
* Added kill feed (includes downs, revives, and bleed outs)
* Added player kills on scoreboard (replaces headshots)
* Spawn points are assigned to a team
* Properly restores dual wield weapon left clip ammo, alternative weapon ammo, and equipment on respawn
* Can only spectate own team

#### Grief
* Gain score by making enemy players bleed out
* Make 10 enemy players bleed out to win the game
* Bleeding out enemy players awards 1000 points to all teammates
* Players respawn after being down for 10 seconds
* Players retain perks

#### Search & Rezurrect
* Win a round by getting all enemy players down
* Win 3 rounds to win the game
* Tie round if both teams die within 5 seconds of eachother
* Players start each round with at least 10000 points
* Bleeding out enemy players awards 1000 points to all teammates
* Amount of players alive on each team shown on HUD
* Enemies remaining audio and text displays when enemy players down instead of when enemy players bleed out
* Last player alive audio only plays for the player who is alive instead of every player on the team
* Audio plays when enemy players bleed out
* Players do not get their weapons back on the next round if they bled out
* Teams switch spawn points each round
* Players respawn at initial spawn points

#### Race
* Gain score by getting zombie kills or getting enemy players down
* Gain 500 score to win the game
* Killing a zombie awards 1 score
* Killing a boss zombie awards 10 score
* Getting an enemy player down awards 10 score
* Reviving an ally player awards 5 score
* Grabbing a Nuke powerup awards 10 score
* Players respawn after being down for 10 seconds
* Players retain perks

#### Containment
* Gain score by being the team with the most players alive in the containment zone
* Gain 250 score to win the game
* Contested if both teams have the same amount of players alive in the containment zone
* Both teams gain score at half rate when contested
* Final score has to be gained uncontested
* Zombies only go after players in the containment zone
* Zombies in the containment zone die when it moves
* Players in the containment zone gain 50 points when their team gains score
* Containment zone moves every 60 seconds
* Next containment zone waypoint shown when there is 10 seconds left on current containment zone
* Amount of players alive in the containment zone on each team shown on HUD
* Players respawn after being down for 10 seconds
* Players retain perks

#### Meat
* Gain score by being the team holding the meat
* Gain 200 score to win the game
* Meat powerup always drops from the first zombie killed
* Player holding the meat gains 100 points when their team gains score
* Downing while holding the meat drops it as a powerup
* Throwing the meat on the ground drops it as a powerup
* Throwing the meat onto another player makes them grab the meat
* Team holding the meat shown on HUD
* Players respawn after being down for 10 seconds
* Players retain perks

### Encounter Pro
* Removed unlimited sprint
* Removed Mystery Box
* Removed Pack-a-Punch

## Launching New Maps

* Go to any lobby of the correct map
* Copy and paste the following commands into the console to launch a map

### Survival on Diner
* ```g_gametype zstandard; ui_gametype zstandard; ui_zm_gamemodegroup zsurvival; ui_zm_mapstartlocation diner; xpartygo```

### Survival on Power Station
* ```g_gametype zstandard; ui_gametype zstandard; ui_zm_gamemodegroup zsurvival; ui_zm_mapstartlocation power; xpartygo```

### Survival on Tunnel
* ```g_gametype zstandard; ui_gametype zstandard; ui_zm_gamemodegroup zsurvival; ui_zm_mapstartlocation tunnel; xpartygo```

### Survival on Cornfield
* ```g_gametype zstandard; ui_gametype zstandard; ui_zm_gamemodegroup zsurvival; ui_zm_mapstartlocation cornfield; xpartygo```

### Grief on Bus Depot
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation transit; xpartygo```

### Grief on Diner
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation diner; xpartygo```

### Grief on Power Station
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation power; xpartygo```

### Grief on Tunnel
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation tunnel; xpartygo```

### Grief on Cornfield
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation cornfield; xpartygo```

### Grief on Docks
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation cellblock; set ui_zm_mapstartlocation_fake docks; xpartygo```

### Grief on Maze
* ```g_gametype zgrief; ui_gametype zgrief; ui_zm_gamemodegroup zencounter; ui_zm_mapstartlocation street; set ui_zm_mapstartlocation_fake maze; xpartygo```

## Launching New Game Modes

* By default, a random game mode will be chosen when launching Grief
* Copy and paste the following commands into the console to choose a specific game mode

### Grief
* ```set ui_gametype_obj zgrief```

### Search & Rezurrect
* ```set ui_gametype_obj zsnr```

### Race
* ```set ui_gametype_obj zrace```

### Containment
* ```set ui_gametype_obj zcontainment```

### Meat
* ```set ui_gametype_obj zmeat```

## Changing Teams (Grief)

* By default, teams are random on Grief
* Copy and paste the following commands into the console to add the option to change teams in the in-game menu

* ```gts allowInGameTeamChange 1; set ui_gametype_team_change 1```